#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/msg.h>

#include <server.h>
#include <structures.h>
#include <custom_sem.h>
#include <custom_shm.h>
#include <errExit.h>

void sigHandlerServer(int sig) {
    if (sig == SIGINT) {
        //TODO:
    }

    if (sig == SIGTERM) {
        //TODO:
    }

    exit(0);
}

int semid;


int main(int argc, char *argv[]){
    input_server_t input = check_input(argc, argv);

    // SIGNAL
    sigset_t mySet;
    sigfillset(&mySet);
    sigdelset(&mySet, SIGINT);
    sigdelset(&mySet, SIGTERM);
    sigprocmask(SIG_SETMASK, &mySet, NULL);

    if (signal(SIGINT, sigHandlerServer) == SIG_ERR) {
        errExit("signal SIGINT", "f4Server");
    }
    if (signal(SIGTERM, sigHandlerServer) == SIG_ERR) {
        errExit("signal SIGTERM", "f4Server");
    }
    //


    // MSGQ
    key_t msgKey = ftok(KEYFILE, 'M');
    int msgid = msgget(msgKey, IPC_CREAT | S_IRUSR | S_IWUSR);
    if (msgid == -1) {
        errExit("msgget", "F4Server");
    }
        // msg
        msg_t msg = {
            .mtype = 1,
            .server_in = input
        };

        // msgsnd
        if (msgsnd(msgid, &msg, sizeof(msg_t)-sizeof(long), 0) == -1) {
            errExit("msgsnd", "F4Server");
        }

    //

    // SHM
    int shmBoardid = getShmid(input.rows, input.collums);
    tile_t *board = shmServerAt(shmBoardid);
    //

    // SEM
    key_t semKey = ftok(KEYFILE, 'S');
    if ((semid = semget(semKey, 2, S_IRUSR | S_IWUSR | IPC_CREAT)) == -1) {
        errExit("getsem", "F4Server");
    }
    
    resetServerSem(semid);
    //



    semOp(semid, 0, 2); // aperurta semaforo per connessione dei due client
    semOp(semid, 0, 0); // aspetto che si connettano i due client


    // faccio quello che devo fare


    


    return 0;
}