#include <stdio.h>

#include <structures.h>

static int col;

void setCollums(int collums) {
	col = collums;
}

int getIndex(int r, int c) {
	return r * col + c;
}

// checks board for a win
// returns player tile_t on win, otherwise 0
tile_t checkWin(tile_t *board, int pos, int rows, int collums) {
	int i;

	tile_t current = board[pos];
	int r = pos / collums;
	int c = pos % collums;

	for (i=0; i<4; i++) {

		// vertical
		if (r + i - 3 >= 0 && r + i < rows) {
			if (board[getIndex(r + i - 3, c)] == board[getIndex(r + i, c)] &&
				board[getIndex(r + i - 2, c)] == board[getIndex(r + i, c)] &&
				board[getIndex(r + i - 1, c)] == board[getIndex(r + i, c)]) {
			
				return current;
			}
		}

		// horizontal
		if (c + i - 3 >= 0 && c + i < collums) {
			if (board[getIndex(r, c + i - 3)] == board[getIndex(r, c + i)] &&
				board[getIndex(r, c + i - 2)] == board[getIndex(r, c + i)] &&
				board[getIndex(r, c + i - 1)] == board[getIndex(r, c + i)]) {
			
				return current;
			}
		}

		// diagonal1
		if (c + i - 3 >= 0 && c + i < collums && r + i - 3 >= 0 && r + i < rows) {
			if (board[getIndex(r + i - 3, c + i - 3)] == board[getIndex(r + i, c + i)] &&
				board[getIndex(r + i - 2, c + i - 2)] == board[getIndex(r + i, c + i)] &&
				board[getIndex(r + i - 1, c + i - 1)] == board[getIndex(r + i, c + i)]) {
			
				return current;
			}
		}

		// diagonal2
		if (c + i + 3 >= 0 && c + i < collums && r - i + 3 < rows && r - i >= 0) {
			if (board[getIndex(r - i + 3, c + i - 3)] == board[getIndex(r - i, c + i)] &&
				board[getIndex(r - i + 2, c + i - 2)] == board[getIndex(r - i, c + i)] &&
				board[getIndex(r - i + 1, c + i - 1)] == board[getIndex(r - i, c + i)]) {
			
				return current;
			}
		}
	}
	
	return EMPTY;
}

tile_t checkWinAll(tile_t *board, int rows, int collums){
	for (int i=0; i<rows*collums; i++) {
		if (checkWin(board, i, rows, collums) != EMPTY) {
			return checkWin(board, i, rows, collums);
		}
	}

	return EMPTY;
}